#!/usr/bin/perl -w

use Pd::Socket::Receive;

$USAGE = "$0 PORT [HOST [PROTO]]
  + PORT is the port to listen on
  + HOST defaults to localhost
  + PROTO is one of 'tcp' or 'udp', default=tcp
";

$UDP_BUFSIZE = 256;

if (!@ARGV) {
  print STDERR "Usage: $USAGE";
  exit 1;
}

##--------------------------------------------------
## Subs
sub serve_tcp {
  my $sock = shift;
  my ($client);
  while ($client = $sock->accept()) {
    while (<$client>) {
      print;
    }
    $client->close();
  }
}

sub serve_udp {
  my $sock = shift;
  my ($rin,$rout,$data,$client);
  $rin = '';
  vec($rin,fileno($sock),1) = 1;
  while (select($rout=$rin, undef, undef, undef)) {
    $data = '';
    $client = $sock->recv($data,$UDP_BUFSIZE,0)
      || die("$0: recv() failed: $!");
    print $data;
  }
}


##--------------------------------------------------
## MAIN
$port = shift(@ARGV);
$host = shift(@ARGV) || 'localhost';
$proto = shift(@ARGV) || 'tcp';

$class = 'Pd::Socket::Receive::';
if ($proto eq 'udp') {
  $class .= 'UDP';
  *server = \&serve_udp;
} else {
  $class .= 'TCP';
  *server = \&serve_tcp;
}

$sock = $class->new(LocalAddr=>$host,LocalPort=>$port)
  or die("$0: could not create socket: $!");

server($sock);

$sock->close();
