#!/usr/bin/perl -w

use Pd::Socket::Send;

$USAGE = "$0 PORT [HOST [PROTO]]
  + PORT is the port to connect to
  + HOST defaults to localhost
  + PROTO is one of 'tcp' or 'udp', default=tcp [udp is broken!]
";

if (!@ARGV) {
  print STDERR "Usage: $USAGE";
  exit 1;
}

$port = shift(@ARGV);
$host = shift(@ARGV) || 'localhost';
$proto = shift(@ARGV) || 'tcp';

$class = 'Pd::Socket::Send::';
if ($proto eq 'udp') {
  $class .= 'UDP';
} else {
  $class .= 'TCP';
}

$sock = $class->new(PeerAddr=>$host,PeerPort=>$port)
  or die("$0: could not create socket: $!");

while (<>) {
  $sock->print($_);
}

$sock->close();
